/*
 * SimpleContainerTest.java
 * JUnit based test
 *
 * Created on 2005/09/14, 22:38
 */

package jp.co.gihyo.book.di.ch2.di;

import junit.framework.*;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author arton
 */
public class SimpleContainerTest extends TestCase {
    static final String TEST_RESOURCE = "simplecontainertest";
    static final String TEST_HELLO_MESSAGE = "I am a camera.";
    
    SimpleContainer container;
    
    public interface TestInterface {
        public String sayHello();
    }
    
    public static class TestClass {
        String testMessage;
        int intValue;
        TestInterface helloObject;
        public void setTestMessage(String newMessage) {
            testMessage = newMessage;
        }
        public void setTestIntValue(int newValue) {
            intValue = newValue;
        }
        public void setHello(TestInterface itf) {
            helloObject = itf;
        }
        public String hello() {
            return helloObject.sayHello();
        }
    }
    
    public static class TestHelloClass implements TestInterface {
        public String sayHello() {
            return TEST_HELLO_MESSAGE;
        }
    }
    
    public SimpleContainerTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        container = new SimpleContainer(TEST_RESOURCE);
    }

    protected void tearDown() throws Exception {
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(new TestSuite(SimpleContainerTest.class));
    }

    /**
     * NX jp.co.gihyo.book.di.ch1.di.SimpleContainer  setterName \bh̃eXg
     */
    public void testSetterName() {
        assertEquals("setThisIs", container.setterName("thisIs"));
    }

    /**
     * NX jp.co.gihyo.book.di.ch1.di.SimpleContainer  getObject \bh̃eXg
     */
    public void testGetObject() {
        Object o = container.getObject("testobject");
        assertTrue(o instanceof TestClass);
        assertEquals("̓eXgbZ[WłB", ((TestClass)o).testMessage);
        assertEquals(32, ((TestClass)o).intValue);
        assertNotNull(((TestClass)o).helloObject);
        assertEquals(TEST_HELLO_MESSAGE, ((TestClass)o).hello());
    }
    
}
