/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * IntegerInjector.java
 *
 * Created on 2005/09/21, 1:58
 *
 */

package jp.co.gihyo.book.di.ch3.intf;

import java.lang.reflect.Method;
import static jp.co.gihyo.book.di.ch3.intf.InjectorHelper.invoke;

/**
 * lCWFNgėpNXB
 *
 * @author arton
 */
class IntegerInjector implements Injector {

    Class targetInterface;
    Object value;
    Method injector;
    
    /**
     * lCWFN^[𐶐B
     * @param initTargetInterface CWFNgΏۂƂȂC^[tFCXB
     * @param initValue CWFNgΏۂ̕B
     */
    IntegerInjector(Class initTargetInterface, String initValue) {
        targetInterface = initTargetInterface;
        for (Method m : targetInterface.getMethods()) {
            if (m.getName().indexOf("inject") == 0 && m.getParameterTypes().length == 1) {
                Class c = m.getParameterTypes()[0];
                if (c == Integer.class || c == Integer.TYPE) {
                    value = new Integer(initValue);
                } else if (c == Long.class || c == Long.TYPE) {
                    value = new Long(initValue);
                } else {
                    continue;
                }
                injector = m;
                break;
            }
        }
    }
 
    public void inject(Injectable target) {
        assert injector != null : "no inject method";
        
        if (targetInterface.isInstance(target)) {
            invoke(injector, target, value);
        }
    }
}
