/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * ServiceLocator.java
 *
 * Created on 2005/09/18, 16:45
 */

package jp.co.gihyo.book.di.ch3.locator;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * T[rXP[^TvB
 *
 * @author arton
 */
public abstract class ServiceLocator {
    
    static final Pattern DEF_OBJECT = Pattern.compile("^class\\.(.+)$");

    static Map<String, ServiceLocator> locators = new HashMap<String, ServiceLocator>();
    static ServiceLocator defaultLocator;
    
    /**
     * w肳ꂽ\[X𗘗p郍P[^T[rX쐬B
     * @param resource vpeBt@C
     * @return P[^
     */
    public static ServiceLocator getService(String resource) throws Exception {
        ServiceLocator locator = locators.get(resource);
        if (locator == null) {
            ResourceBundle rb = ResourceBundle.getBundle(resource);
            locators.put(resource, locator = new DefaultImpl());
            if (defaultLocator == null) {
                defaultLocator = locator;
            }
            ((DefaultImpl)locator).initialize(rb);
        }
        return locator;
    }
    
    /**
     * ftHg̃P[^T[rX擾B
     * @return ftHgP[^T[rX
     * @throws IllegalStateException ܂P[^T[rXĂȂ
     */
    public static ServiceLocator getService() {
        if (defaultLocator == null) {
            throw new IllegalStateException("not yet initialized");
        }
        return defaultLocator;
    }
    
    /**
     * w肳ꂽ̂̃\[X擾B
     * @param name \[X
     * @return w肳ꂽOɑΉ郊\[X
     */
    public abstract Object lookup(String name);

    static class DefaultImpl extends ServiceLocator {
        Map<String, Object> objects;
        
        void initialize(ResourceBundle rb) throws Exception {
            objects = new HashMap<String, Object>();
            HashMap<String, Class> cls = new HashMap<String, Class>();
            for (Enumeration<String> keys = rb.getKeys(); keys.hasMoreElements();) {
                String key = keys.nextElement();
                Matcher m = DEF_OBJECT.matcher(key);
                if (m.matches()) {
                    cls.put(m.group(1), Class.forName(rb.getString(key)));
                } else {
                    objects.put(key, rb.getString(key));
                }
            }
            for (Map.Entry<String, Class> ent : cls.entrySet()) {
                objects.put(ent.getKey(), ent.getValue().newInstance());
            }
        }
        public Object lookup(String name) {
            return objects.get(name);
        }
    }
}
