/*
 * AnnotationInjectContainerTest.java
 * JUnit based test
 *
 * Created on 2005/09/24, 12:29
 */

package jp.co.gihyo.book.di.ch3.ano;

import jp.co.gihyo.book.di.ch3.ano.*;
import junit.framework.*;

/**
 *
 * @author arton
 */
public class AnnotationInjectContainerTest extends TestCase {

    static final String TEST_PROP_FILE = "annotationdi";
    static final String TEST_OBJ = "anotestobject";
    
    AnnotationInjectContainer dicon;
    
    public AnnotationInjectContainerTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        dicon = new AnnotationInjectContainer(TEST_PROP_FILE);
    }

    protected void tearDown() throws Exception {
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(AnnotationInjectContainerTest.class);
    }

    public static class TestClass {
        @Inject(type=Inject.Type.NAME,value="surName")
        String familyName;
        @Inject(type=Inject.Type.NAME,value="givenName")
        String firstName;
        @Inject(type=Inject.Type.NAME)
        int age;
        @Inject
        TestHello hello;
    }
    
    public interface TestHello {
        String getMessage();
    }
    
    @Injectable(TestHello.class)
    public static class TestHelloClass implements TestHello {
        @Inject(type=Inject.Type.NAME)
        String message;
        public String getMessage() {
            return message;
        }
    }
    /**
     * NX jp.co.gihyo.book.di.ch2.ano.AnotationInjectContainer  getObject \bh̃eXg
     */
    public void testGetObject() {
        TestClass test = (TestClass)dicon.getObject(TEST_OBJ);
        assertNotNull(test);
        assertEquals("Y", test.firstName);
        assertEquals("RobNX", test.familyName);
        assertEquals(27, test.age);
        assertEquals("ɂ₪", test.hello.getMessage());
    }
    
}
