/*
 * InterfaceInjectContainerTest.java
 * JUnit based test
 *
 * Created on 2005/09/21, 2:17
 */
package jp.co.gihyo.book.di.ch3.intf;

import junit.framework.*;

/**
 *
 * @author arton
 */
public class InterfaceInjectContainerTest extends TestCase {

    static final String TEST_PROP_FILE = "interfacedi";
    static final String TEST_OBJ = "itftestobject";
    
    InterfaceInjectContainer dicon;
    
    public InterfaceInjectContainerTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        dicon = new InterfaceInjectContainer(TEST_PROP_FILE);
    }

    protected void tearDown() throws Exception {
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(InterfaceInjectContainerTest.class);
    }

    public interface InjectSurName extends Injectable {
        void injectSurName(String newSurName);
    }
    public interface InjectGivenName extends Injectable {
        void injectGivenName(String newGivenName);
    }
    public interface InjectAge extends Injectable {
        void injectAge(int newAge);
    }
    public interface InjectTestHello extends Injectable {
        void injectTestHello(TestHelloClass newHello);
    }
    public interface InjectMessage extends Injectable {
        void injectMessage(String newMessage);
    }
        
    public static class TestClass implements InjectSurName, InjectGivenName, InjectAge, InjectTestHello {
        String surName;
        String givenName;
        int age;
        TestHelloClass hello;

        public void injectSurName(String newSurName) {
            surName = newSurName;
        }
        public void injectGivenName(String newGivenName) {
            givenName = newGivenName;
        }
        public void injectAge(int newAge) {
            age = newAge;
        }
        public void injectTestHello(TestHelloClass newHello) {
            hello = newHello;
        }
    }

    public static class TestHelloClass implements InjectMessage {
        String message;
        public void injectMessage(String newMessage) {
            message = newMessage;
        }
    }
    
    /**
     * NX jp.co.gihyo.book.di.ch2.intf.InterfaceInjectContainer  getObject \bh̃eXg
     */
    public void testGetObject() {
        TestClass test = (TestClass)dicon.getObject(TEST_OBJ);
        assertNotNull(test);
        assertEquals("Y", test.givenName);
        assertEquals("RobNX", test.surName);
        assertEquals(27, test.age);
        assertEquals("ɂ₪", test.hello.message);
    }
    
}
