/*
 * ServiceLocatorTest.java
 * JUnit based test
 *
 * Created on 2005/09/24, 17:05
 */

package jp.co.gihyo.book.di.ch3.locator;

import junit.framework.*;

/**
 *
 * @author arton
 */
public class ServiceLocatorTest extends TestCase {

    static final String TEST_PROP_FILE = "locator";
    static final String TEST_OBJ = "testobject";
    
    ServiceLocator locator;
    
    public ServiceLocatorTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
        locator = ServiceLocator.getService(TEST_PROP_FILE);
    }

    protected void tearDown() throws Exception {
    }
    
    public static void main(String[] args) {
        junit.textui.TestRunner.run(ServiceLocatorTest.class);
    }

    public static class TestClass {
        public TestClass() {
            ServiceLocator locator = ServiceLocator.getService();
            surName = (String)locator.lookup("surName");
            givenName = (String)locator.lookup("givenName");
            age = Integer.parseInt((String)locator.lookup("age"));
        }
        void setup() {
            // IuWFNg͏Ɏ擾
            ServiceLocator locator = ServiceLocator.getService();
            hello = (TestHelloClass)locator.lookup("testHelloObject");
        }
        String surName;
        String givenName;
        int age;
        TestHelloClass hello;
    }
    
    public static class TestHelloClass {
        String message;
        public TestHelloClass() {
            ServiceLocator locator = ServiceLocator.getService();
            message = (String)locator.lookup("message");
        }
    }
    
    public void testLocator() throws Exception {
        TestClass test = (TestClass)locator.lookup(TEST_OBJ);
        test.setup();
        assertEquals("Y", test.givenName);
        assertEquals("RobNX", test.surName);
        assertEquals(27, test.age);
        assertEquals("ɂ₪", test.hello.message);
    }
}
