/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * HelloClient.java
 *
 * Created on 2005/10/06, 2:56
 *
 */

package jp.co.gihyo.book.di.ch4;

/**
 *
 * @author arton
 */
public class HelloClient {
    
    Hello hello;
    
    public HelloClient(Hello initHello) {
        hello = initHello;
    }
    
    public void runHello() {
        System.out.println(hello.greeting());
        Thread.yield();
        hello.greet("good bye");
    }
    
    static void runHello(final Hello hello) throws InterruptedException {
        Thread[] ts = new Thread[5];
        for (int i = 0; i < ts.length; i++) {
            ts[i] = new Thread(new Runnable() {
                public void run() {
                    new HelloClient(hello).runHello();
                }
            });
            ts[i].start();
        }
        for (Thread t : ts) {
            t.join();
        }
    }
            
    public static void main(String[] args) throws InterruptedException {
        // IWi
        System.out.println("-----original hello-----");
        Hello hello = new HelloImpl();
        runHello(hello);
        // g[XC^[Zv^
        System.out.println("-----trace hello-----");
        hello = MethodInterceptor.weave(Hello.class, hello, new TraceInterceptor());
        runHello(hello);
        // C^[Zv^{g[XC^[Zv^
        System.out.println("-----synchronized hello-----");
        hello = MethodInterceptor.weave(Hello.class, hello, new SynchronizationInterceptor());
        runHello(hello);
    }
    
}
