/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * MethodInterceptor.java
 *
 * Created on 2005/10/02, 2:42
 *
 */

package jp.co.gihyo.book.di.ch4;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

/**
 * \bhĂяoC^[ZvgNXB
 * @author arton
 */
public abstract class MethodInterceptor {
    
    static final Object[] NOARGS = new Object[0];
    
    /**
     * VK̃C^[Zv^ԑB
     * @param klass C^[ZvgΏۂ̃C^[tFCX
     * @param obj ĂяoC^[ZvgIuWFNg
     * @param itc \bhĂяoC^Zv^
     */
    @SuppressWarnings({"unchecked"})
    public static<T> T weave(Class<T> klass, final T obj, final Interceptor itc) {
        return (T)Proxy.newProxyInstance(klass.getClassLoader(), new Class[] { klass },
            new InvocationHandler() {
                public Object invoke(Object proxy, Method m, Object[] args) throws Throwable {
                    if (args == null) {
                        args = NOARGS;
                    }
                    try {
                        itc.beforeInvoke(m, args);
                        Object o = m.invoke(obj, args);
                        itc.afterInvoke(m, args, o);
                        return o;
                    } catch (Throwable e) {
                        if (e instanceof InvocationTargetException) {
                            e = e.getCause();
                            itc.exception(m, args, e);
                        }
                        throw e;
                    }
                }
            });
    }
    
    /**
     * \bhĂяoC^[Zvg邽߂̃C^[tFCXB
     */
    public interface Interceptor {
        /**
         * \bhĂяoOɌĂяoB
         * @param m ĂяoΏۃ\bh
         * @param args Ăяop[^
         */
        void beforeInvoke(Method m, Object[] args);
        /**
         * \bhĂяoɌĂяoB
         * @param m ĂяoΏۃ\bh
         * @param args Ăяop[^
         * @param result Ăяo
         */
        void afterInvoke(Method m, Object[] args, Object result);
        /**
         * \bh̗Oɂ钆fɌĂяoB
         * @param m ĂяoΏۃ\bh
         * @param args Ăяop[^
         * @param e X[ꂽO
         */
        void exception(Method m, Object[] args, Throwable e);
    }
}
