/* Copyright(c) 2005 arton
 *
 * Usage of the works is permitted provided that this instrument is retained with the works,
 * so that any entity that uses the works is notified of this instrument.
 *
 * DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
 *
 * SynchronizationInterceptor.java
 *
 * Created on 2005/10/06, 2:51
 *
 */

package jp.co.gihyo.book.di.ch4;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * \bhĂяo𓯊C^[Zv^B
 * @author arton
 */
public class SynchronizationInterceptor implements MethodInterceptor.Interceptor {
    
    Lock lock = new ReentrantLock();
    
    public void beforeInvoke(java.lang.reflect.Method m, Object[] args) {
        lock.lock();
        System.out.println("locked by " + Thread.currentThread().getName());
    }

    public void exception(java.lang.reflect.Method m, Object[] args, Throwable e) {
        System.out.println("unlocked by " + Thread.currentThread().getName());
        lock.unlock();
    }

    public void afterInvoke(java.lang.reflect.Method m, Object[] args, Object result) {
        System.out.println("unlocked by " + Thread.currentThread().getName());
        lock.unlock();
    }
   
}
